/*
 * (C) Copyright 2004-2011 Texas Insturments
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 *
 * (C) Copyright 2002
 * Gary Jennejohn, DENX Software Engineering, <gj@denx.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifdef CONFIG_4460NXSTB

#ifndef _PKCS15_STRUCT_H_
#define _PKCS15_STRUCT_H_

typedef struct
{
    u32 size;                               // modulus size in bytes
    u32 e;                                  // public exponent
    u8  n[256];                             // modulus
} CERT_KEYS_RSAPublicKey_t;

typedef struct
{
    u8 *ipSign;
    u32 inSignLen;
    u8 *ipM;
    u32 inMLen;
    u32 inRSAPubKeyID;
} CERT_PKCS_V1_5_Verify_Struct;

typedef struct
{
  u8 magic[8];
  u32 version;
  u32 type;
} CERT_info_t;

typedef struct
{
  u32 PK;
  u32 PPA;
  u32 RD1;
  u32 RD2;
  u32 ISW;
  u32 KI;
  u32 PAU;
  u32 PAS;
} CERT_KM_Min_Version_t;

typedef struct
{
  u32 signer_info[4];
  u32 signature_info;
  u32 key_id;
  u32 signature[256];
} CERT_KEYS_RSASignature_t;

typedef struct
{
    CERT_info_t info;
    CERT_KM_Min_Version_t min_version;
    u32 Boot_SWD;
    CERT_KEYS_RSAPublicKey_t rootkey;
    u32 keys_nbr;
    CERT_KEYS_RSAPublicKey_t aux_keys[6];
    u32 PK_KI_limitation;
    u32 MSV_mask;
    u32 MSV;
    u8 spare[120];
    CERT_KEYS_RSASignature_t signature;
} CERT_PublicKeys_t;

#endif

#endif /* CONFIG_4460NXSTB */
