/* ____________________________________________________________________________
*   Created 2010, (C) Copyright 2010 Texas Instruments.  All rights reserved.
*   Filename   : ppa_call.c          
*____________________________________________________________________________*/


/*_______________________________ Include Files _____________________________*/

#include <stdarg.h>
#include <common.h>

#undef OMAP4430
#define OMAP4460

#ifdef OMAP4430
#define PUBLIC_API_BASE (0x00028400)
#endif
#ifdef OMAP4460
#define PUBLIC_API_BASE (0x00030400)
#endif

#define PUBLIC_API_SEC_ENTRY                            (0x00)

#define FLAG_FIQ_ENABLE             0x1
#define FLAG_IRQ_ENABLE             0x2
#define FLAG_START_HAL_CRITICAL     0x4

#define  API_HAL_RET_VALUE_FAIL     0x00000001


typedef u32 (** const PUBLIC_SEC_ENTRY_Pub2SecDispatcher_pt) \
               (u32 appl_id, u32 proc_ID, u32 flag, ...);
#define PUBLIC_SEC_ENTRY_Pub2SecDispatcher \
      (*(PUBLIC_SEC_ENTRY_Pub2SecDispatcher_pt) \
                                   (PUBLIC_API_BASE+PUBLIC_API_SEC_ENTRY))

u32 SEC_ENTRY_Std_Ppa_Call (u32 appl_id, u32 inNbArg, ...)
{
  u32 result;
  u32 Param[4];
  va_list ap;

  va_start(ap, inNbArg);

  switch (inNbArg)
  {
    case 0:
      result = PUBLIC_SEC_ENTRY_Pub2SecDispatcher(
                   appl_id,
                   0,  // TBDJL needs to be explained
                   FLAG_IRQ_ENABLE | FLAG_FIQ_ENABLE | FLAG_START_HAL_CRITICAL, 
                   inNbArg);
      break;

    case 1:
      Param[0] = va_arg(ap, u32);
      result = PUBLIC_SEC_ENTRY_Pub2SecDispatcher(
                   appl_id,
                   0,  // TBDJL needs to be explained
                   FLAG_IRQ_ENABLE | FLAG_FIQ_ENABLE | FLAG_START_HAL_CRITICAL, 
                   inNbArg, Param[0]);
      break;
                   
    case 2:
      Param[0] = va_arg(ap, u32);
      Param[1] = va_arg(ap, u32);
      result = PUBLIC_SEC_ENTRY_Pub2SecDispatcher(
                   appl_id,
                   0,  // TBDJL needs to be explained
                   FLAG_IRQ_ENABLE | FLAG_FIQ_ENABLE | FLAG_START_HAL_CRITICAL, 
                   inNbArg, Param[0], Param[1]);
      break;             
                   
    case 3:
      Param[0] = va_arg(ap, u32);
      Param[1] = va_arg(ap, u32);
      Param[2] = va_arg(ap, u32);
      result = PUBLIC_SEC_ENTRY_Pub2SecDispatcher(
                   appl_id,
                   0,  // TBDJL needs to be explained
                   FLAG_IRQ_ENABLE | FLAG_FIQ_ENABLE | FLAG_START_HAL_CRITICAL, 
                   inNbArg, Param[0], Param[1], Param[2]);
       break;
    case 4:
      Param[0] = va_arg(ap, u32);
      Param[1] = va_arg(ap, u32);
      Param[2] = va_arg(ap, u32);
      Param[3] = va_arg(ap, u32);
      result = PUBLIC_SEC_ENTRY_Pub2SecDispatcher(
                   appl_id,
                   0,  // TBDJL needs to be explained
                   FLAG_IRQ_ENABLE | FLAG_FIQ_ENABLE | FLAG_START_HAL_CRITICAL, 
                   inNbArg, Param[0], Param[1], Param[2], Param[3]);
      break;
    default:
    // for the moment, we support only 4 parameters max.
  
      return API_HAL_RET_VALUE_FAIL;

  }
  va_end(ap);                                            
  return result;
}

/*_______________________________ Local Functions ___________________________*/
